const Oracle = require('./oracle/Oracle');
const Connection = require('./oracle/Connection');

const defaultFetchParams = {
  outputObj: true,
}

class DB {
  static instance = null;
  static connection = null;
  constructor(instance, connection) {
    DB.instance = DB.instance || instance;
    DB.connection = DB.connection || connection;
  }
  async connect() {
    return DB.connection.connect();
  }
  async disconnect() {
    return DB.connection.disconnect();
  }
  async commit() {
    return DB.connection.commit();
  }
  async rollback() {
    return DB.connection.rollback();
  }
  async beginTransaction() {
    return DB.instance.beginTransaction();
  }
  async fetch(sql, queryParams = {}, fetchParams = defaultFetchParams) {
    return DB.instance.fetch(sql, queryParams, fetchParams);
  }
  async execute(sql, params, executionParams) {
    return DB.instance.execute(sql, params, executionParams);
  }
  async executeProcedure(name, procedureParams) {
    return DB.instance.executeProcedure(name, procedureParams);
  }
}

module.exports = new DB(Oracle, Connection);