const DB = require('../database/DB');

class Filial {
  GET_ACTIVE_UNITS = `
    SELECT
      CDFILIAL,
      NMFILIAL
    FROM
      FILIAL
    WHERE
      IDATIVO = 'S'
    ORDER BY
      CDFILIAL
  `;

  GET_UNITS = `
    SELECT
      F.CDFILIAL,
      F.NMFILIAL,
      F.NRORG,
      (
        SELECT
          COUNT(1)
        FROM CAIXA C
        WHERE
          C.CDFILIAL = F.CDFILIAL AND
          C.IDTPEMISSAOFOS = 'SAT'
      ) AS SAT
      FROM FILIAL F
      WHERE
        UPPER(F.NMFILIAL) NOT LIKE '%INAT%'
      GROUP BY
        F.CDFILIAL,
        F.NMFILIAL,
        F.NRORG
    ORDER BY
    F.CDFILIAL
  `;

  getActiveUnits() {
    return DB.fetch(this.GET_ACTIVE_UNITS);
  }

  getUnits() {
    return DB.fetch(this.GET_UNITS);
  }
}

module.exports = new Filial();