const DB = require("../database/DB");

class UpdaterProdConfigFili {
  INSERT = `
    INSERT INTO UPDATERPRODCONFIGFILI (
      CDPRODUCTID,
      CDFILIAL,
      NRVERSAO,
      CONFIG
    ) VALUES (
      :CDPRODUCTID,
      :CDFILIAL,
      :NRVERSAO,
      :CONFIG
    )
  `;

  UPDATE = `
    UPDATE UPDATERPRODCONFIGFILI
    SET
      CONFIG = :CONFIG,
      DTULTATU = SYSDATE
    WHERE
      CDFILIAL    = :CDFILIAL    AND
      CDPRODUCTID = :CDPRODUCTID AND
      NRVERSAO    = :NRVERSAO
  `;

  GET_PRODUCT_CONFIG = `
    SELECT
      CONFIG
    FROM
      UPDATERPRODCONFIGFILI
    WHERE
      CDFILIAL    = :CDFILIAL    AND
      CDPRODUCTID = :CDPRODUCTID AND
      NRVERSAO    = :NRVERSAO
  `;

  GET_LATEST_PROD_CONFIG = `
    SELECT
      CONFIG
    FROM
      UPDATERPRODCONFIGFILI
    WHERE
      CDPRODUCTID  = :CDPRODUCTID         AND
      CDFILIAL     = :CDFILIAL            AND
      NRVERSAO <> NVL(:NRVERSAO, 'X.X.X') AND
      CONFIG IS NOT NULL
    ORDER BY
      DTINCLUSAO DESC
  `;

  insert(params, executionParams = {}) {
    return DB.execute(this.INSERT, params, executionParams);
  }

  update(params, executionParams = {}) {
    return DB.execute(this.UPDATE, params, executionParams);
  }

  getProductConfig(params) {
    return DB.fetch(this.GET_PRODUCT_CONFIG, params);
  }

  getLatestProdConfig(params) {
    return DB.fetch(this.GET_LATEST_PROD_CONFIG, params);
  }
}

module.exports = new UpdaterProdConfigFili();